#include<stdio.h>
main()
{
	int n,k,i;
	scanf("%d %d", &n, &k);
	int niz[n];
	for(i=0;i<n;i++)
	{
		scanf("%d", &niz[i]);	
	}
	
	int rezultat = ukupnaSuma(niz,n,k,0);
	printf("%d",(rezultat % (1000000000 + 7)));
}

int ukupnaSuma(int niz[], int n, int k, int l)
{
	int rez=0,i,j=0;
	int suma = 0;
	int tempSuma = 0;
	if(k==0)
	{
		while(l<n)
		{
			suma+=niz[l];
			l++;
		}	
		
	} else if(k>0) {
		while(j<n)
		{
			int x = j;
			while(x<=n)
			{
				suma = suma + ukupnaSuma(niz,x,k-1,j);
				x++;
			}
			j++;
		}
	}
	return suma;
}